<?php
header('Content-Type: text/html; charset=UTF-8');
function register1()
{
	// Особая, curl-ная магия
	$ch = curl_init(); // Инициализируем сессию
	curl_setopt($ch, CURLOPT_URL,"http://moemesto.ru/register/"); // задаем адрес формы
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1); // Результат нам нужно вернуть в переменную, а не на экран
	curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1); // Переходить по редиректам
	curl_setopt($ch, CURLOPT_COOKIEJAR, 'cookie.txt'); // Указываем файл для хранения кукисов
	
	// Выполняем запрос
	$result = curl_exec($ch);
	
	// При помощи простейшего регулярного выражения добываем сессионный ключ
	preg_match('#<input type=hidden name="captchaid" value="([a-f0-9]+)">#i', $result, $key);
	
	curl_setopt($ch, CURLOPT_URL,"http://moemesto.ru/captcha/$key[1]"); // задаем адрес картинки
	$result = curl_exec($ch); // Скачиваем картинку
	curl_close ($ch); // Закрываем сессию
	
	file_put_contents('captcha.jpg', $result); // Сохраняем
	
	return $key[1]; // Возвращаем добытый ключ
}

// Функция, производящая регистрацию
function register2($login, $email, $password, $captcha, $key)
{
	// Все POST-параметры, которые надо отправить
	$post = array(
		'captchaid'	=> $key // Передаем сессионный ключ
		'login'		=> $login, // Логин
		'email'		=> $email, // Емейл
		'password'	=> $password, // Пароль
		'captcha'	=> $captcha, // А это наш код с картинки
		'do_reg'	=> 'Зарегистрироваться', // "Нажимаем" кнопку отправить ;-)
	);

	// Особая, curl-ная магия
	$ch = curl_init(); // Инициализируем сессию
	curl_setopt($ch, CURLOPT_URL,"http://moemesto.ru/register/"); // задаем адрес обработчика формы
	curl_setopt($ch, CURLOPT_POST, 1); // Указываем, что нам нужно отправить POST-запрос
	curl_setopt($ch, CURLOPT_POSTFIELDS, $post); // Передаем POST-параметры
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1); // Результат нам нужно вернуть в переменную, а не на экран
	curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1); // Переходить по редиректам
	curl_setopt($ch, CURLOPT_COOKIEJAR, 'cookie.txt'); // Указываем файл для хранения кукисов. При чем он должен быть тот же, что и в прошлый раз, чтобы кукисы подхватились.
	
	// Запускаем запрос!
	$result = curl_exec($ch);
	curl_close ($ch); // Закрываем сессию
	
	// Проверяем на успешность регистрации
	//echo $result;
	if(strstr($result, 'Поздравляем! Вы успешно зарегистрировались!'))
	{
		return true;
	}
	else
	{
		return false;
	}
}

// Параметры регистрации. Их можно задавать руками, или считывать из файла - на ваше усмотрение.
$login = 'antifrager323';
$email = 'antifrag233@yopmail.com';
$password = 'qwerty';

// Выводим, что мы будем регать
echo "Логин: $login, пароль: $password, email: $email<br/>";

// Получаем капчу и сессионный ключ
$key = register1();

// Подключаем апи антикапчи
require('ac_curl.php');
// Распознаем капчу. Список и значение параметров функции можно узнать в начале файла.
// Чем точнее параметры будут описывать капчу, тем больше точность распознавания
$captcha=recognize("captcha.jpg","ваш_api_key",true, 5 120, 0, 0, 1, 4, 6);
// На всякий случай показываем картинку и распознанный текст
echo '<img src="captcha.jpg"><br>Text:'.$captcha.'<br>';

// Регаем
if(register2($login, $email, $password, $captcha, $key))
{
	echo 'Успешно зарегистрирован';
}
else
{
	echo '<b>Ошибка регистрации</b>';
}
echo '<br><a href="'.basename(__FILE__).'">Еще раз</a>';
// Все!  ;-)
?>